<?php
  // This page look for the given email, by POST Ajax.
  // If the email exists, and accept files, send back the short ID of the
  // user.

  // Look for the email in LDAP (retreive the UID), and then look in the
  // DBMS if this uid accept files. If it is the case, send the associated
  // shortID

  error_reporting (E_ALL);
  header ("Content-Type: text/plain ; charset=utf-8");
  header ("Cache-Control: no-cache, private");
  header ("Pragma: no-cache");

  require ("functions.php");
  require ("LDAP/chercher.php");
  require ("Strings/verifParam.php");

  if (! isset ($_POST['mail']))
  {
    trigger_error ('Mail argument not given', E_USER_ERROR);
    $result = array ('success'=>FALSE, 
                     'error'=> t ('Mail argument not given'));
    die (json_encode ($result));
  }

  if (! emailOK ($_POST['mail']))
  {
    trigger_error ("Mail argument '".$_POST['mail']."' is incorrect",
                   E_USER_ERROR);
    $result = array ('success'=>FALSE, 
                     'error'=> t ('Mail argument is incorrect'));
    die (json_encode ($result));
  }
  $mail = $_POST['mail'];

  // Check if the mail is in MySQL. If it doesn't exists, do a LDAP request if
  // LDAP is supported
  // MySQL
  $sql = "SELECT uid FROM auth WHERE mail='$mail' AND Allow=1";
  $result = mysql_query ($sql);
  if ($result === FALSE)
  {
    trigger_error ("SQL ERROR : $sql", E_USER_ERROR);
    $result = array ('success'=>FALSE,
                     'error'=> t ("SQL ERROR"));
    die (json_encode ($result));
  }
  if (mysql_num_rows ($result) !== 1)
  {
    if ($conf['LDAPAllowed'] === TRUE)
    {
      $ret = chercher ($conf['ldap_base'], "(mail=$mail)", array ("uid"), 
                       $conf['ldap_server'], $conf['ldap_port'], 
                       $conf['ldap_bindDN'], $conf['ldap_bindPassword']);

      if (is_string ($ret))
      {
        trigger_error ("LDAP Error : $ret", E_USER_ERROR);
        $result = array ('success'=>FALSE,
                         'error'=> t ($ret));
        die (json_encode ($result));
      }

      if (!isset ($ret[0]['uid'][0]))
      {
        if ($conf['debug'] > 0)
          trigger_error ("Email address '$mail' not known in SQL and LDAP",
                          E_USER_WARNING);
        $result = array ('success'=>FALSE,
                         'error'=> t ('Email address not known in SQL and LDAP'));
        die (json_encode ($result));
      }

      $uid = $ret[0]['uid'][0];

    }
    else
    {
      trigger_error ("Not found '$mail' in DB or Allow=0", E_USER_ERROR);
      $result = array ('success'=>FALSE,
                       'error'=> t ("Mail not found or don't accept files"));
      die (json_encode ($result));
    }
  }
  else
  {
    $res = mysql_fetch_assoc($result);
    $uid = $res['uid'];
  }

  if (! loginOK ($uid))
  {
    trigger_error ("LDAP Error : UID '$uid' incorrect", E_USER_ERROR);
    $result = array ('success'=>FALSE,
                     'error'=> t ('LDAP Error : UID incorrect'));
    die (json_encode ($result));
  }

  // SQL
  if (($sid = UidAcceptFiles ($uid)) === FALSE)
  {
    trigger_error ("Error : UID '$uid' don't accept files in MySQL",
                    E_USER_ERROR);
    $result = array ('success'=>FALSE,
                     'error'=> t ("Error : UID don't accept files"));
    die (json_encode ($result));
  }

  if (! checkShortID ($sid))
  {
    trigger_error ("Error : ShortID found in MySQL is incorrect '$sid'",
                    E_USER_ERROR);
    $result = array ('success'=>FALSE,
                     'error'=> t ("Error : ShortID found is incorrect"));
    die (json_encode ($result));
  }
 
  if ($conf['debug'] > 0) 
    trigger_error ("SID Found for '$uid' -> '$sid'", E_USER_NOTICE);
  $result = array ('success'=>TRUE,
                   'sid'=>$sid);
  die (json_encode ($result)); 
?>
