<?php
  // Default configuration
  // Should be copied in /etc/uploadto.conf before modification

 // Logs and debug
  error_reporting (E_ALL);
  set_include_path (get_include_path().":/usr/share/libphp");
  $conf['debug'] = 0;
  $conf['logFile'] = 'logs/uploadto.log';

  // LDAP
  $conf['LDAPAllowed'] = FALSE; // Set it to TRUE to check the users in LDAP.
                                // FALSE use just the MySQL database
  $conf['ldap_server'] = 'localhost';
  $conf['ldap_port'] = 389;
  $conf['ldap_base'] = '';
  $conf['ldap_bindDN'] = NULL;
  $conf['ldap_bindPassword'] = NULL;

  // MySQL
  $conf['mysql_server'] = 'localhost';
  $conf['mysql_user'] = 'mysql_user';
  $conf['mysql_password'] = 'mysql_password';
  $conf['mysql_database'] = 'mysql_database';

  // HTML Login page
  // Title
  $conf['wwwTitle']['fr'] = "Service d'Upload";
  $conf['wwwTitle']['us'] = "Upload Service";
  $conf['wwwTitle']['gb'] = "Upload Service";
  $conf['wwwTheme'] = 'normal';
  $conf['wwwLogo'] = "themes/normal/logo.png";
  $conf['wwwFooter']['fr'] = "Contact : <a href='mailto:service'>Service</a>";
  $conf['wwwFooter']['us'] = "Contact : <a href='mailto:service'>Service</a>";
  $conf['wwwFooter']['gb'] = "Contact : <a href='mailto:service'>Service</a>";

  // Languages
  $conf['languagesEnabled'] = array ("fr", "us", "gb");
  $conf['defaultLanguage'] = "fr";

  // Upload (both in the same partition for move performance and atomic access)
  $conf['uploadTmp'] = '/tmp';
  $conf['uploadDirUserBase'] = '/tmp/dest';
  
  // Download
  // Method : fopen or readfile
  // In my tests, readfile is slower and use MUCH more apache RAM.
  $conf['downloadMethod'] = 'fopen';

  // Mail
  // Informations necessary to send the mail to the final user.
  $conf['smtp_host'] = 'smtp.example.com';
  $conf['smtp_user'] = '';
  $conf['smtp_pass'] = '';
  $conf['smtpDownloadURL'] = 'http://upload2.example.com/dl';
  // smtpQuickURL is the beginning of the URL with user SID WITH SLASH
  $conf['smtpQuickURL'] = 'http://upload2.example.com/';
  $conf['smtp_from'] = 'Computing Service <service@example.com>';
  $conf['smtp_subject'] = '[UPLOAD Service] New file available / Nouveau fichier disponible';
  // The mail content is defined in theme. The download URL is substitute from
  // <DOWNLOADURL> field, and <DOWNLOADURLCLEAR> is the readable version of
  // the URL.
  // Attached are file put in mail attachment. 
  // $attach[] = array ('nom'=>'nom du fichier', 
  //                    'attach'=>'inline',
  //                    'mime-type'=>'image/png; charset=binary;');
  // If attach=>'inline' is defined, the image is put in the HTML page, but the
  // src must be coded like : <img src='cid:NomDuFichierImage.ext'/> 
  $conf['smtp_attached'] = array();
  $conf['smtp_attached'][] = array('nom'=>'themes/normal/logo.png', 'attach'=>'inline',
                                   'mime-type'=>'image/png; charset=binary');

  // Removing files
  // <FILELIFETIME> can be used in mail
  $conf['filesLifetime'] = 7; // in days

  // Quota by default
  $conf['quotaSizeDefault'] = NULL;   // in bytes, NULL=no quota
  $conf['quotaNumberDefault'] = NULL; // in number of files, NULL=no quota

  // vim:filetype=php syntax=php
?>
