<?php
  // Configuration interface 

  // DON'T USE IT IN PRODUCTION WITHOUT MODIFICATION !!
  error_reporting (E_ALL);

  // Parameter to be given by your user site:
  $uid = "dominique.fournier";


  require ("functions.php");
  require ("Strings/verifParam.php");
  require ("Strings/strings.php");
  require ("LDAP/chercher.php");

  /////////////////
  //   HEADERS   //
  /////////////////
  require ("themes/".$conf['wwwTheme']."/HTMLhead.php");

  //////////////////////////////////
  //   CONTENT CREATE AND SEARCH  //
  //////////////////////////////////
  if (!UidExists ($uid))
  {
    // Uid don't exists : create it
    $datas = createIDs ($uid);
    $shortID = $datas['shortID'];
    $longID = $datas['longID'];
    // Define defaults quotas
    updateQuota ($uid, $conf['quotaSizeDefault'], $conf['quotaNumberDefault']);
  }
  else
  {
    // Uid exists : read its informations (by createID, it's normal...)
    $datas = createIDs ($uid);
    $shortID = $datas['shortID'];
    $longID = $datas['longID'];
  }

  ////////////////////////
  //   CONTENT UPDATE   //
  ////////////////////////
  $erreur = "";
  if (isset ($_POST['submit']))
  {
    if (isset ($_POST['mail']))
    {
      if (emailOK ($_POST['mail']))
        updateMail ($uid, $_POST['mail']);
      else
      {
        $error = t ("ERROR : incorrect mail provided")."<br/>\n";
      }
    }

    if (isset ($_POST['state'])) $state = TRUE;
    else $state = FALSE;
    updateAllow ($uid, $state);
  }

  /////////////////////////////
  //   SEARCH ACTUAL DATAS   //
  /////////////////////////////
  $usedQuotas = FileStatsUsedQuotaUser ($uid);
  $quotaSize = HumanReadableValue ($definedQuotas['quotaSize']);
  $quotaNumber = $definedQuotas['quotaNumber'];
  if ($quotaNumber === NULL) $quotaNumber = 0;
  $definedQuotas = FileStatsDefinedQuotaUser ($uid);
  if ($definedQuotas['quotaSize'] === NULL)
    $quotaSizeMax = t("NO LIMIT");
  else
    $quotaSizeMax = HumanReadableValue ($definedQuotas['quotaSize'])." ".
                    t("bytes");
  if ($definedQuotas['quotaNumber'] === NULL)
    $quotaNumberMax = t("NO LIMIT");
  else
    $quotaNumberMax = $definedQuotas['quotaNumber']." ".t("files");

  $state = ShortIDacceptFiles ($shortID);
  $mail = UidMail ($uid);
  if ($mail === NULL && $conf['LDAPAllowed'] !== FALSE)
  {
    // No user mail defined, but LDAP allowed : look for in LDAP
    $ret = chercher ($conf['ldap_base'], "(uid=$uid)", array ("mail"),
                     $conf['ldap_server'], $conf['ldap_port'],
                     $conf['ldap_bindDN'], $conf['ldap_bindPassword']);
    
    if (is_array ($ret) && isset ($ret[0]['mail'][0]))
    {
      // Found one : save it (the user don't need to click to record to validate
      // his email address
      $mail = $ret[0]['mail'][0];
      updateMail ($uid, $mail);
    }
    else
      $mail = "";
  }

  $files = FileStatsList ($uid);

  /////////////////
  //   DISPLAY   //
  /////////////////
  require ("themes/".$conf['wwwTheme']."/configuration-page.php");

  /////////////////
  //   FOOTERS   //
  /////////////////
  require ("themes/".$conf['wwwTheme']."/HTMLfooter.php");

?>
