<?php

  // dl.php

  // Download the given file.
  // The file can be download by : 
  // http://uploadfilewithuser/dl/dfhdfhd/file.ext

  require ("functions.php");

  // Le urldecode permet de recuperer des fichiers contenant un espace (qui est
  // code par un + dans PATH_INFO
  $filetmp = $conf['uploadDirUserBase']."/".urldecode($_SERVER['PATH_INFO']);
  $file = realpath ($filetmp);
  if (strpos ($file, $conf['uploadDirUserBase']) !== 0 || $file === FALSE)
  {
    header ("HTTP/1.0 403 Forbidden");
    trigger_error ("File not allowed : '$filetmp'", E_USER_ERROR);
    die ("File access forbidden");
  }
  
  if (!file_exists ($file) || strlen ($_SERVER['PATH_INFO']) < 5)
  {
    header ("HTTP/1.0 404 Not Found");
    trigger_error ("File not found : '$file'", E_USER_ERROR);
    die ("File not found");
  }

  if (!is_file ($file))
  {
    header ("HTTP/1.0 404 Not Found");
    trigger_error ("File '$file' is not a file", E_USER_ERROR);
    die ("File is not a file");
  }

  @apache_setenv('no-gzip', 1);
  @ini_set('zlib.output_compression', 0);

  trigger_error ("File download '$file' start", E_USER_NOTICE);
  $size = filesize ($file);
  $startTime = microtime(TRUE);
  header ('Content-Description: File Transfer');
  header ('Content-Type: application/octet-stream');
  header ('Content-Disposition: attachment; filename="'. basename ($file).'"');
  header ('Content-Transfer-Encoding: binary');
  header ('Expires: 0');
  header ('Cache-Control: must-revalidate, post-check=0, pre-check=0');
  header ('Pragma: public');
  header ('Content-Length: '. $size);
  // ob_end_flush kill the PHP cache (don't use memory to buffer the file before
  // send).
  // Display immediately the panel to record the file on the disk
  // Do it only if output buffer is active
  if (ob_get_length()) ob_end_flush ();
  flush ();
  if ($conf['downloadMethod'] === "readfile")
  {
    // readfile OK but eats the apache RAM and is slower for big files
    readfile ($file);
  }
  else
  {
    // The procedure is faster, eat more CPU but LESS apache RAM.
    // Each download eats $chunksize Mo of RAM
    // 10Mo in the example
    $chunksize = 10*(1024*1024); // how many bytes per chunk
    $handle = fopen($file, 'rb');
    if ($handle === false) 
    {
      die ("error");
    }
    while (!feof($handle))
    {
      echo fread($handle, $chunksize);
    }
    fclose($handle); 
  }
  $endTime = microtime(TRUE);
  trigger_error ("File download '$file' end (".
                 round ($endTime-$startTime)."s, ".
                 round ($size/1000/($endTime-$startTime))."Ko/s, ".
                 round (memory_get_usage()/1000000)."MoRAM, ".
                 round (memory_get_peak_usage()/1000000)."MoRAM Peak".
                 ")",
                 E_USER_NOTICE);
  // Put an exit to be sure that files will not be damaged by a space at the end
  exit;
?>
