<?php
  require ("config-default.php");
  require ("HTML/language.php");
  require ("ErreursLogs/erreur.php");

  if (file_exists ("/etc/uploadto.conf"))
    require ("/etc/uploadto.conf");
  elseif (file_exists ("uploadto.conf.php"))
    require ("uploadto.conf.php");
  else
  {
    $fatal = t ('Configuration not available : copy config-default.php to /etc/uploadto.conf or uploadto.conf.php and configure it');
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }

  error_reporting (E_ALL);
  set_error_handler ('errorlog');

  // Connection to MySQL
  $link = mysql_connect ($conf['mysql_server'], $conf['mysql_user'],
                         $conf['mysql_password']);
  if ($link === FALSE)
  {
    trigger_error ('Connection to MySQL in error : '.mysql_error(), 
                   E_USER_ERROR);
    $fatal = t ('Connection to MySQL in error');
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }

  if (mysql_select_db ($conf['mysql_database']) === FALSE)
  {
    trigger_error ('Connection to MySQL in error : '.mysql_error(), 
                   E_USER_ERROR);
    $fatal = t ('Connection to MySQL in error');
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }
  if ($conf['LDAPAllowed'] !== FALSE && !function_exists ("ldap_connect"))
  {
    trigger_error ('LDAP support disabled or not installed on this server',
                   E_USER_ERROR);
    $fatal = t ('LDAP support disabled or not installed on this server');
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }

  function checkShortID ($shortID)
  {
    // Return TRUE if $shortID is correct
    // Return FALSE elsewhere
    if (strlen ($shortID) < 5 || strlen ($shortID) > 255)
      return FALSE;
    $shortID = strtolower ($shortID);
    if (strspn ($shortID, "abcdefghijklmnopqrstuvwxyz0123456789") ===
        strlen ($shortID))
      return TRUE;
    return FALSE;
  }

  function checkFileName ($name)
  {
    // This function check if the given name contains only correct characters
    // Return TRUE if the name is OK
    // Return FALSE if the name is BAD
    if (strpos ($name, "/") !== FALSE)
      return FALSE;
    for ($i = 0 ; $i < strlen ($name) ; $i++)
    {
      if (ord ($name[$i]) <= 31)
        return FALSE;
      if (ord ($name[$i]) == 127)
        return FALSE;
    }
    return TRUE;
  }

  function ShortIDacceptFiles ($sid)
  {
    // Check if the shortID given accept files
    // Return FALSE if not,
    // Return uid of this shortID if it accept files
    $sql = "SELECT uid FROM auth WHERE shortID='$sid' AND allow=TRUE";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      return FALSE;
    }
    $row = mysql_fetch_assoc($result);
    return $row['uid'];
  }

  function UidExists ($uid)
  {
    // Check if the given uid exists in database
    // Return FALSE if not
    // Return TRUE if it is
    $sql = "SELECT uid FROM auth WHERE uid='$uid'";
        $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      return FALSE;
    }
    $row = mysql_fetch_assoc($result);
    return TRUE;
  }

  function UidLists ()
  {
    // Return an array containing the defined uids with SID and LID and mail
    $sql = "SELECT uid,shortID,longID,mail FROM auth";
    $result = mysql_query ($sql);
    $res = array();
    while ($row = mysql_fetch_assoc($result))
    {
      $res[] = $row;
    }
    return $res;
  }

  function UidAcceptFiles ($uid)
  {
    // Check if the $uid given accept files
    // Return the shortID of the given UID, if it accept the files
    $sql = "SELECT shortID FROM auth WHERE uid='$uid' AND allow=TRUE";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      return FALSE;
    }
    $row = mysql_fetch_assoc($result);
    return $row['shortID'];
  }

  function UidMail ($uid)
  {
    // Check if the $uid given has defined a mail to be contacted
    // Return FALSE if not
    // Return defined mail if it is
    $sql = "SELECT mail FROM auth WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) > 0)
    {
      $datas = mysql_fetch_assoc($result);
      return $datas['mail'];
    }
    return FALSE;
  }

  function createIDs ($uid)
  {
    // Create the IDs for given UID. If the UID already exists, do nothing and 
    // return a table with the informations concerning this UID
    $sql = "SELECT shortID, longID, Allow FROM auth WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) > 0)
    {
      // This UID exists in database, don't add it
      return mysql_fetch_assoc($result);
    }

    // Create shortID and longID.
    // This block should be atomic, but I don't know how.
    do {
      $shortID = mt_rand (100000,999999);
      $longID = mt_rand (100000000,999999999).mt_rand (100000000,999999999);
      $sql = "SELECT shortID, longID FROM auth WHERE shortID=$shortID OR 
              longID=$longID";
      $result = mysql_query ($sql);
    } while (mysql_num_rows ($result) !== 0);

    $sql = "INSERT INTO auth SET shortID=$shortID, longID=$longID, uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("Creation in DB of IDs in error : ". mysql_error());
      return FALSE;
    }
    return array ('shortID'=>$shortID, 'longID'=>$longID);
  }

  function updateAllow ($uid, $state)
  {
    // This function update the Allow flag (allowing receiving of files).
    // $state must be true or false;
    // Return FALSE if the UID doesn't exists
    // Return TRUE if the record is correct
    $sql = "SELECT Allow FROM auth WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      // This UID doesn't exists in database, don't change allow
      trigger_error ("ERROR updateAllow : UID '$uid' not recorded in DB",
                     E_USER_ERROR);
      return FALSE;
    }
    $sql = "UPDATE auth SET Allow='$state' WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("Update of Allow in DB of IDs in error [value already ".
                     "recorded for '$uid']");
      return FALSE;
    }
    return TRUE;
  }

  function updateMail ($uid, $mail)
  {
    // This function define the user mail or remove it if the $mail is NULL
    // Return FALSE if the UID doesn't exists
    // Return TRUE if the record is correct
    $sql = "SELECT mail FROM auth WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      // This UID doesn't exists in database, don't change allow
      trigger_error ("ERROR updateMail : UID '$uid' not recorded in DB",
                     E_USER_ERROR);
      return FALSE;
    }
    if ($mail === NULL)
      $sql = "UPDATE auth SET mail=NULL WHERE uid='$uid'";
    else
      $sql = "UPDATE auth SET mail='$mail' WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("Update of mail in DB of IDs in error [value already ".
                     "recorded for '$uid']");
      return FALSE;
    }
    return TRUE;
  }

  function updateQuota ($uid, $quotaSize, $quotaNumber)
  {
    // This function define the user quota or remove it if the $quotaXX is 0
    // If the $quotaXX is NULL, don't change the value
    // Return FALSE if the UID doesn't exists
    // Return TRUE if the record is correct
    $sql = "SELECT quotaSize, quotaNumber FROM auth WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_num_rows ($result) === 0)
    {
      // This UID doesn't exists in database, don't change allow
      trigger_error ("ERROR updateQuota : UID '$uid' not recorded in DB",
                     E_USER_ERROR);
      return FALSE;
    }
    $sql = "UPDATE auth SET ";
    if ($quotaSize !== NULL)
      $sql .= "quotaSize=$quotaSize";
    if ($quotaSize !== NULL && $quotaNumber !== NULL)
      $sql .= ", ";
    if ($quotaNumber !== NULL)
      $sql .= "quotaNumber=$quotaNumber";
    $sql .= " WHERE uid='$uid'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("Update of quota in DB of IDs in error [value already ".
                     "recorded for '$uid']");
      return FALSE;
    }
    return TRUE;
  }

  function FileStatsList ($uid)
  {
    // This function return the lists of available files for $uid
    $sql = "SELECT filename, uploadDate, size FROM fileStats WHERE uid='$uid'";
    $result = mysql_query ($sql);
    $list = array();
    if (mysql_affected_rows() === 0)
      return array();
    while ($datas = mysql_fetch_assoc($result))
    {
      $list[] = $datas;
    }
    return $list;
  }

  function FileStatsAddFile ($uid, $file, $size)
  {
    // This function add the file to the FileStats table, or update it if it already
    // exists
    $sql = "INSERT INTO fileStats SET uid='$uid', filename='".addslashes ($file)."',
                                      uploadDate=NOW(), size=$size ON DUPLICATE KEY
            UPDATE size=$size";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("FileStatsAddFile : add '$uid', '$file', '$size' : ".
                     mysql_error(), E_USER_ERROR);
      return FALSE;
    }
    return TRUE;
  }

  function FileStatsRenFile ($fileold, $filenew)
  {
    // This function rename the fileold to filenew in the FileStats table
    // exists
    $sql = "UPDATE fileStats SET filename='".addslashes ($filenew)."' WHERE
                                 filename='".addslashes ($fileold)."'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("FileStatsRenFile : rename '$fileold' to '$filenew' : ".
                     mysql_error(), E_USER_ERROR);
      return FALSE;
    }
    return TRUE;
  }
  
  function FileStatsDelFile ($file)
  {
    // This function delete the given file from the database
    $sql = "DELETE FROM fileStats WHERE filename='".addslashes ($file)."'";
    $result = mysql_query ($sql);
    if (mysql_affected_rows() !== 1)
    {
      trigger_error ("FileStatsDelFile : Del '$file' : ". mysql_error(),
                     E_USER_ERROR);
      return FALSE;
    }
    return TRUE;
  }

  function FileStatsUsedQuotaUser ($uid)
  {
    // This function return an array with used quotaSize et quotaNumber for user
    $sql = "SELECT COUNT(uid) AS quotaNumber, SUM(size) AS quotaSize FROM fileStats
            WHERE uid='$uid'";
    $result = mysql_query ($sql);
    return mysql_fetch_assoc($result);
  }
  
  function FileStatsDefinedQuotaUser ($uid)
  {
    // This function return an array with defined quotaSize et quotaNumber for user
    $sql = "SELECT quotaSize, quotaNumber FROM auth WHERE  uid='$uid'";
    $result = mysql_query ($sql);
    return mysql_fetch_assoc($result);
  }
?>
