<?php
  error_reporting (E_ALL);

  require ("functions.php");
  require ("LDAP/chercher.php");

  ////////////////////////
  //   Initial Checks   //
  ////////////////////////
  if (! file_exists ($conf['uploadTmp']) && 
      ! is_writeable (dirname ($conf['uploadTmp'])))
  {
    trigger_error ($conf['uploadTmp']." doesn't exists and could not be created"
                   , E_USER_ERROR);
    $fatal = t ("Temp dir doesn't exists and could not be created");
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }

  if (! file_exists ($conf['uploadDirUserBase']) && 
      ! is_writeable (dirname ($conf['uploadDirUserBase'])))
  {
    trigger_error ($conf['uploadDirUserBase'].
                   " doesn't exists and could not be created",
                   E_USER_ERROR);
    $fatal = t ("User Dir doesn't exists and could not be created");
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }
  if (file_exists ($conf['uploadTmp']) && ! is_dir ($conf['uploadTmp']))
  {
    trigger_error ("ERROR : ".$conf['uploadTmp']." is not a directory",
                   E_USER_ERROR);
    $fatal = t ("Temp dir is not a directory");
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }
  if (file_exists ($conf['uploadDirUserBase']) &&
      ! is_dir ($conf['uploadDirUserBase']))
  {
    trigger_error ("ERROR : ".$conf['uploadDirUserBase']." is not a directory",
                   E_USER_ERROR);
    $fatal = t ("User Dir is not a directory");
    require ("themes/".$conf['wwwTheme']."/fatal-page.php");
  }

  if (! file_exists ($conf['uploadTmp']))
  {
    trigger_error ("Create ".$conf['uploadTmp']);
    mkdir ($conf['uploadTmp']);
  }
  if (! file_exists ($conf['uploadDirUserBase']))
  {
    trigger_error ("Create ".$conf['uploadDirUserBase']);
    mkdir ($conf['uploadDirUserBase']);
  }

  ///////////////////////////////////////
  //   SID Given : checks before use   //
  ///////////////////////////////////////
  $javascript = "";
  $sidjs = "NOPE";
  if (isset ($_GET['sid']))
  {
    // Short id
    if (checkShortID ($_GET['sid']) === FALSE)
    {
      trigger_error ("Short ID '".$_GET['sid']."' is incorrect (illegal ".
                     "characters, too short, too long)", E_USER_ERROR);
      $fatal = t ("Short ID is incorrect");
      require ("themes/".$conf['wwwTheme']."/fatal-page.php");
    }
    $sid = $_GET['sid'];
    if (($uid = ShortIDacceptFiles ($sid)) === FALSE)
    {
      trigger_error ("Short ID '$sid' don't accept files", E_USER_ERROR);
      $fatal = t ("This Short ID don't accept files");
      require ("themes/".$conf['wwwTheme']."/fatal-page.php");
    }

    /*
    // I comment this code, because if the user exists in MySQL, I don't want to
    // ask anything to LDAP. MySQL is mandatory, but LDAP is optionnal !
    // LDAP : check if the user always exists in LDAP
    $ret = chercher ($conf['ldap_base'], "(uid=$uid)", array ("uid"),
                     $conf['ldap_server'], $conf['ldap_port'],
                     $conf['ldap_bindDN'], $conf['ldap_bindPassword']);

    if (is_string ($ret))
    {
      trigger_error ("LDAP Error : $ret", E_USER_ERROR);
      $result = array ('success'=>FALSE,
                       'error'=> t ($ret));
      trigger_error ("The Shortid '$sid' have uid='$uid' and uid don't ".
                     "exists dans LDAP", E_USER_ERROR);
      $fatal = t ("This Short ID don't exists in LDAP");
      require ("themes/".$conf['wwwTheme']."/fatal-page.php");
    }*/

    $sidjs = $sid;
  }
  else
  {
    $javascript .= "<script type='text/javascript' src='ajaxMail.js'>".
                   "</script>\n";
  }
  $javascript .= "<script type='text/javascript'>var sid = '$sidjs';".
                 "</script>\n";
  
  $javascript .= "<script type='text/javascript' src='upload.js'></script>\n";
  require ("themes/".$conf['wwwTheme']."/HTMLhead.php");
  require ("themes/".$conf['wwwTheme']."/index-page.php");
  require ("themes/".$conf['wwwTheme']."/HTMLfooter.php");
?>
